/* http://groups.google.com/group/comp.lang.xharbour/browse_thread/thread/192d70053039e419/49ac3d70c0606f5a?fwc=1
   http://www.rhinocerus.net/forum/lang-xharbour/129122-tone-not-work-windows-vista-business.html
   http://objectmix.com/xharbour/192852-tone-not-work-windows-vista-business.html

   this is andi's hbtone.prg from old xharbour news 8 feb 2007
   add winmm.lib to your link script */

// #define __TEST__

// #ifdef __TEST__
// PROCEDURE MAIN()

// LOCAL n := 0
// LOCAL i

// FOR i := 1 TO 10
// n += 10
// OutStd( "Volume="+str(n,,,.T.) + chr(10) )
// tone(850,2,.T.,n)
// tone(900,5,.T.,n)
// tone(800,2,.T.,n)
// tone(950,10,.T.,n)
// tone(700,2,.T.,n)
// tone(1200,2,.T.,n)
// tone(800,2,.T.,n)
// tone(900,8,.T.,n)
// NEXT

// RETURN
// #endif

#PRAGMA BEGINDUMP
/*
TONE() for Windows to replace the ugly-heard GT Tone :-)
Mono approach. Duration has been roughly estimated to be Cli**per-like,
please refer to tests/sound.prg.
Using Windows MMsystem, sound card is a must in order to make
this function work.

Syntax: TONE( nFreq, nDuration, [ lSmooth ], [ nVol ] ) -> NIL

nFreq = INTEGER, Tone frequency
nDuration = NUMERIC, Duration Time, as in Cl**per
lSmooth = LOGICAL, pass .F. to disable sound smoothing, default is .T.
nVol = INTEGER, Sound Intensity/Volume, value 0 - 127, Default
127 ( Max )

Andi Jahja <harbour@cbn.net.id>
*/
#include "hbapi.h"
#include <windows.h>
#include <mmsystem.h>
#include <math.h>

#define SAMPLING_RATE 44100
void HB_EXPORT hb_winTone( UINT, double, BOOL, UINT );

//----------------------------------------------------------------------------//
HB_FUNC( TONE )
{
if ISNUM( 1 )
{
hb_winTone( hb_parni( 1 ),
( ISNUM( 2 ) ? hb_parnd( 2 ) : 1.0 ) * 2100,
ISLOG( 3) ? hb_parl( 3 ) : TRUE,
ISNUM( 4 ) ? hb_parni( 4 ) : 127 );
}
}
//---------------------------------------------------------------------------
/* Keep it here for access from C programs */
void HB_EXPORT hb_winTone( UINT uFrequency, double dwDuration, BOOL
bSmoothing, UINT uVolume )
{
WAVEFORMATEX wfx;
HWAVEOUT hWaveOut = NULL;

wfx.wFormatTag = WAVE_FORMAT_PCM;
wfx.nChannels = 1;
wfx.nSamplesPerSec = SAMPLING_RATE;
wfx.nAvgBytesPerSec = SAMPLING_RATE;
wfx.nBlockAlign = 1;
wfx.wBitsPerSample = 8;
wfx.cbSize = 0;

/*
WAVE_MAPPER is the most commonly used device
CallBack is unnecessary since we only play simple tone
*/
if( waveOutOpen( &hWaveOut, WAVE_MAPPER, &wfx, NULL, NULL,
CALLBACK_NULL ) == MMSYSERR_NOERROR )
{
char amp = uVolume;
int i;
unsigned char* buffer = (unsigned char*) hb_xgrab( (ULONG)
dwDuration );
double dKoef = uFrequency * 2 * 3.1416 / SAMPLING_RATE;
WAVEHDR wh;

if ( buffer )
{
wh.lpData = (LPSTR) buffer;
wh.dwBufferLength = (DWORD) dwDuration;
wh.dwFlags = WHDR_BEGINLOOP;
wh.dwLoops = 1;

if( waveOutPrepareHeader( hWaveOut, &wh, sizeof( wh ) ) ==
MMSYSERR_NOERROR )
{
wh.dwFlags = WHDR_BEGINLOOP | WHDR_ENDLOOP | WHDR_PREPARED;
wh.dwLoops = 1;

if ( bSmoothing )
{
/*
Manipulating data to smooth sound from clicks at the start
and end (particularly noted when we call TONE() many times
in a row). This is a simulation of increasing volume
gradually
before it reaches the peak, and decreasing volume gradually
before it reaches the end.
*/
for( i = 0; i < dwDuration; i++ )
{
if ( i < amp )
{
buffer[ i ] = (unsigned char) ( cos( i * dKoef ) *
i + 127 );
}
else if ( dwDuration - i <= amp - 1 )
{
amp = max( 0, --amp );
buffer[ i ] = (unsigned char) ( cos( i * dKoef ) *
amp + 127 );
}
else
{
buffer[ i ] = (unsigned char) ( cos( i * dKoef ) *
amp + 127 );
}
}
}
else
{
/*
Raw sound, may cause annoying clicks when some tones are
played
in a row.
*/
for( i = 0; i < (int) dwDuration; i++ )
{
buffer[ i ] = (unsigned char) ( cos( i * dKoef ) *
amp + 127 );
}
}

/*
Play the sound here
*/
if ( waveOutWrite( hWaveOut, &wh, sizeof(WAVEHDR) ) ==
MMSYSERR_NOERROR )
{
/*
Wait until the sound is finished
*/
while (!(wh.dwFlags & WHDR_DONE))
{
Sleep( 1 );
}

waveOutUnprepareHeader(hWaveOut, &wh, sizeof(WAVEHDR));
}
}

hb_xfree( buffer );
}
}
}

#PRAGMA ENDDUMP


